// naive solution to test the testing environment
// makes at most N^2/4 queries

#include <iostream>
#include <vector>
using namespace std;

int main() {
	int n, k; cin >> n >> k;

	vector<int> s = {1, n}; // we know p[1] < p[n]
	for (int i = 2; i < n; ++i) {
		for (int j = 0; ; ) {
			cout << "? 3 " << i << " " << s[j] << " " << s[j + 1] << endl;
			int x; cin >> x;
			if (x == s[j]) { // p[i] < p[s[j]] < p[s[j + 1]]
				s.insert(s.begin() + j, i);
				break;
			}
			if (x == i) { // p[s[j]] < p[i] < p[s[j + 1]]
				s.insert(s.begin() + j + 1, i);
				break;
			}
			if (x == s[j + 1]) { // p[s[j]] < p[s[j + 1]] < p[i]
				if (j + 2 == s.size()) {
					s.push_back(i);
					break;
				} else if (j + 3 == s.size()) {
					j += 1;
				} else {
					j += 2;
				}
			}
		}
	}

	cout << "!";
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (s[j] == i) {
				cout << " " << 1 + j;
			}
		}
	}
	cout << endl;
}
