# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, q = [int(_) for _ in fi.readline().split()]
if 1 > n or n > 10**5:
	sys.exit('N out of range')
if 1 > q or q > 10**5:
	sys.exit('Q out of range')
fo.write('{0} {1}\n'.format(n, q))

a = [int(_) for _ in fi.readline().split()]
for i in range(n):
	if 1 > a[i] or a[i] > 10**9:
		sys.exit('A[{0}] out of range'.format(1 + i))
	if i > 0 and a[i - 1] < a[i]:
		sys.exit('A[{i}] increases'.format(1 + i))
fo.write('{0}\n'.format(' '.join([str(_) for _ in a])))

c = 0
for i in range(q):
	t, x, y = [int(_) for _ in fi.readline().split()]
	if 1 > t or t > 2:
		sys.exit('T[{0}] out of range'.format(1 + i))
	if t == 1:
		c += 1
	if 1 > x or x > n:
		sys.exit('X[{0}] out of range'.format(1 + i))
	if 1 > y or y > 10**9:
		sys.exit('Y[{0}] out of range'.format(1 + i))
	fo.write('{0} {1} {2}\n'.format(t, x, y))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 1000 and q <= 1000:
		print('subtask 1')
	elif c == 0:
		print('subtask 2')
	else:
		print('subtask 3')
