# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

t = int(fi.readline().strip())
if 1 > t or t > 2:
	sys.exit('T out of range')
fo.write('{0}\n'.format(t))

n = int(fi.readline().strip())
if 3 > n or n > 10**5:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

e = [[] for _ in range(n)]
for i in range(n - 1):
	a, b = [int(_) for _ in fi.readline().split()]
	if 1 > a or a > n:
		sys.exit('A[{0}] out of range'.format(1 + i))
	if 1 > b or b > n:
		sys.exit('B[{0}] out of range'.format(1 + i))
	e[a - 1].append(b - 1)
	e[b - 1].append(a - 1)
	fo.write('{0} {1}\n'.format(a, b))

u = [0 for _ in range(n)]
q = [0]
i = 0
while i < len(q):
	if u[q[i]] == 0:
		q += e[q[i]]
		u[q[i]] = 1
	i += 1
if sum(u) != n:
	fo.write('Network not connected\n')

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if t == 1 and n <= 300:
		print('subtask 1')
	elif t == 1:
		print('subtask 2')
	elif t == 2 and n <= 300:
		print('subtask 3')
	elif t == 2 and n <= 3000:
		print('subtask 4')
	else:
		print('subtask 5')
