#include <bits/stdc++.h>
#include "testlib.h"
using namespace std;

struct edge {
  int u, v;
  edge(int u, int v) : u(u), v(v) {}
};

int main(int argc, char** argv) {
  registerGen(argc, argv, 1);
  int t = atoi(argv[1]);
  int type = atoi(argv[2]);
  int n = atoi(argv[3]);
  int k = atoi(argv[4]);
  std::vector<edge> edges;
  if (type == 0) {
    for (int i = 1; i < n; i++) {
      edges.emplace_back(i, rnd.wnext(i, k));
    }
  } else if (type == 1) {
    edges.emplace_back(0, 1);
    edges.emplace_back(1, 2);
    edges.emplace_back(2, 3);
    int sz = (n - 4) / 2;
    for (int i = 4; i < 4 + sz; i++) {
      edges.emplace_back(0, i);
    }
    for (int i = 4 + sz; i < n; i++) {
      edges.emplace_back(3, i);
    }
  } else if (type == 2) {
    for (int i = 1; i < n / 2; i++) {
      edges.emplace_back(i - 1, i);
    }
    for (int i = n / 2; i < n; i++) {
      edges.emplace_back(n / 2 - 1, i);
    }
  } else if (type == 3) {
    for (int i = 1; i < k; i++) {
      edges.emplace_back(i - 1, i);
    }
    int sz = (n - k) / 2;
    for (int i = k; i < k + sz; i++) {
      edges.emplace_back(0, i);
    }
    for (int i = k + sz; i < n; i++) {
      edges.emplace_back(k - 1, i);
    }
  }
  shuffle(edges.begin(), edges.end());
  cout << t << endl;
  cout << n << endl;
  std::vector<int> p = rnd.perm(n);
  for (int i = 0; i < edges.size(); i++) {
    cout << p[edges[i].u] + 1 << " " << p[edges[i].v] + 1 << endl;
  }
  return 0;
}
