# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, k = [int(_) for _ in fi.readline().split()]
if 2 > n or n > 1300:
	sys.exit('N out of range')
if 1 > k or k > 2020:
	sys.exit('K out of range')
fo.write('{0} {1}\n'.format(n, k))

p = [int(_) for _ in fi.readline().split()]
if len(p) != n:
	sys.exit('Invalid length of P')
fo.write(' '.join([str(_) for _ in p]))
fo.write('\n')

p.sort()
for i in range(n):
	if p[i] != i + 1:
		sys.exit('P not a permutation of 1..N')

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 8 and k == 2020:
		print('subtask 1')
	elif n <= 8 and k == 42:
		print('subtask 2')
	elif n <= 8 and k == 13:
		print('subtask 3')
	elif n <= 100 and k == 2020:
		print('subtask 4')
	elif n <= 400 and k == 2020:
		print('subtask 5')
	elif n <= 1000 and k == 2020:
		print('subtask 6')
	elif n <= 1300 and k == 2020:
		print('subtask 7')
	else:
		print('no subtask')
