// naive solution to test the testing environment
// makes at most N^2/4 queries

// rename to lelud.java before compiling

import java.io.*;
import java.util.*;

public class lelud {
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);

		StringTokenizer tok = new StringTokenizer(in.readLine());
		int n = Integer.parseInt(tok.nextToken());
		int k = Integer.parseInt(tok.nextToken());

		ArrayList<Integer> s = new ArrayList<Integer>();
		s.add(1); s.add(n); // we know p[1] < p[n]
		for (int i = 2; i < n; ++i) {
			for (int j = 0; ; ) {
				out.println("? 3 " + i + " " + s.get(j) + " " + s.get(j + 1));
				out.flush();
				int x = Integer.parseInt(in.readLine());
				if (x == s.get(j)) { // p[i] < p[s[j]] < p[s[j + 1]]
					s.add(j, i);
					break;
				}
				if (x == i) { // p[s[j]] < p[i] < p[s[j + 1]]
					s.add(j + 1, i);
					break;
				}
				if (x == s.get(j + 1)) { // p[s[j]] < p[s[j + 1]] < p[i]
					if (j + 2 == s.size()) {
						s.add(i);
						break;
					} else if (j + 3 == s.size()) {
						j += 1;
					} else {
						j += 2;
					}
				}
			}
		}

		out.print("!");
		for (int i = 1; i <= n; ++i) {
			for (int j = 0; j < n; ++j) {
				if (s.get(j) == i) {
					out.print(" " + (1 + j));
				}
			}
		}
		out.flush();
	}
}
