// makes 1.5*N queries

#include <bits/stdc++.h>
using namespace std;

int n, k;
const int maxN = 1305;

int ask(const vector<int> & p) {
    cout << "? " << p.size();
    for (int c : p) {
        cout << " " << c;
    }
    cout << endl;
    int resp;
    cin >> resp;
    return resp;
}

int sz;
int par[maxN][2];

int main() {
    cin >> n >> k;
    vector<int> ans(1 + n, -1);
    vector<int> vals(n);
    iota(vals.begin(), vals.end(), 1);
    if (n % 2 == 1) {
        int pos = ask(vals);
        ans[pos] = (n + 1) / 2;
    }
    int l, r;
    if (n % 2 == 0) {
        l = n / 2;
        r = n / 2 + 1;
    } else {
        l = (n + 1) / 2 - 1;
        r = (n + 1) / 2 + 1;
    }
    for (int step = 0; step < n / 2; step++) {
        vector<int> what;
        for (int i = 1; i <= n; i++) {
            if (ans[i] == -1) {
                what.emplace_back(i);
            }
        }
        assert(what.size() % 2 == 0);
        int c = what.back();
        what.pop_back();
        int pos_ml = ask(what);
        what.erase(find(what.begin(), what.end(), pos_ml));
        what.push_back(c);
        int pos_mr = ask(what);
        ans[pos_ml] = l;
        ans[pos_mr] = r;
        par[sz][0] = pos_ml;
        par[sz][1] = pos_mr;
        sz++;
        l--;
        r++;
    }
    int p1 = par[sz - 1][0], pn = par[sz - 1][1];
    assert(ans[p1] == 1 && ans[pn] == n);
    for (int i = 0; i < (sz - 1); i++) {
        if (ask({p1, par[i][0], par[i][1]}) == par[i][1]) {
            swap(ans[par[i][0]], ans[par[i][1]]);
        }
    }
    if (ans[1] > ans[n]) {
        for (int i = 1; i <= n; i++) {
            ans[i] = n + 1 - ans[i];
        }
    }
    cout << "! ";
    for (int i = 1; i <= n; i++) {
        cout << ans[i] << " ";
    }
    cout << endl;
}
