#include <iostream>
#include <algorithm>
#include <cstdlib>
using namespace std;

int main(int argc, const char *argv[]) {
	int n = atoi(argv[1]);
	int q = atoi(argv[2]);
	int m = atoi(argv[3]);
	int t = atoi(argv[4]);
	srand(n + q + m + t);

	cout << n << ' ' << q << '\n';

	int *a = new int[n];
	for (int i = 0; i < n; ++i) {
		a[i] = 1 + random() % m;
	}
	sort(a, a + n);

	long long *s = new long long[n];
	s[0] = a[0];
	for (int i = 1; i < n; ++i) {
		s[i] = s[i - 1] + a[i];
	}
	reverse(s, s + n);

	reverse(a, a + n);
	for (int i = 0; i < n; ++i) {
		if (i > 0) cout << ' ';
		cout << a[i];
	}
	cout << '\n';

	for (int i = 0; i < q; ++i) {
		if (t == 1 && random() % 2 == 0) {
			int x1 = random() % n;
			int x2 = random() % (x1 + 1);
			int y1 = max(a[x1] - 1, 1);
			int y2 = min(a[x2] + 1, 1000000000);
			int y = y1 + random() % (y2 - y1 + 1);
			cout << 1 << ' ' << 1 + x1 << ' ' << y << '\n';
		} else {
			int x = random() % n;
			int y = random() % min(s[x], 1000000000LL);
			cout << 2 << ' ' << 1 + x << ' ' << 1 + y << '\n';
		}
	}
}
