#include <bits/stdc++.h>
using namespace std;

int64_t sqr(int x) {
    return 1ll * x * x;
}

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    int n;
    cin >> t;
    cin >> n;
    if (t == 1) {
        cout << sqr(n - 2) << endl;
        return 0;
    }
    vector<vector<int>> ed(n);
    for (int i = 0; i + 1 < n; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        ed[u].push_back(v);
        ed[v].push_back(u);
    }
    vector<int> tin(n);
    vector<int> tout(n);
    int tr = 0;
    vector<int> sz(n, 1);
    std::function<void(int, int)> dfs = [&] (int v, int p) {
        tr++;
        tin[v] = tr;
        for (auto to : ed[v]) {
            if (to == p) {
                continue;
            }
            dfs(to, v);
            sz[v] += sz[to];
        }
        tout[v] = tr;
    };
    vector<bool> used(n);
    int SZ = 0;
    std::function<void(int)> stupid = [&] (int v) {
        used[v] = true;
        SZ++;
        for (auto to : ed[v]) {
            if (used[to]) {
                continue;
            }
            stupid(to);
        }
    };
    int64_t ans = sqr(n - 2);
    dfs(0, -1);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int u = i;
            int v = j;
            for (int x = 0; x < n; x++) used[x] = false;
            used[u] = used[v] = true;
            int64_t cur = 0;
            for (int x = 0; x < n; x++) {
                if (!used[x]) {
                    stupid(x);
                    cur += 1LL * SZ * SZ;
                    SZ = 0;
                }
            }
            ans = min(ans, cur);
        }
    }
    cout << ans << endl;
}
