#include <bits/stdc++.h>
using namespace std;

int64_t sqr(int x) {
  return 1ll * x * x;
}

int main() {
  ios_base::sync_with_stdio(false);
  int t;
  int n;
  cin >> t;
  cin >> n;
  if (t == 1) {
    cout << sqr(n - 2) << endl;
    return 0;
  }
  vector<vector<int>> ed(n);
  for (int i = 0; i + 1 < n; i++) {
    int u, v;
    cin >> u >> v;
    u--; v--;
    ed[u].push_back(v);
    ed[v].push_back(u);
  }
  vector<int> tin(n);
  vector<int> tout(n);
  int tr = 0;
  vector<int> sz(n, 1);
  std::function<void(int, int)> dfs = [&] (int v, int p) {
    tr++;
    tin[v] = tr;
    for (auto to : ed[v]) {
      if (to == p) {
        continue;
      }
      dfs(to, v);
      sz[v] += sz[to];
    }
    tout[v] = tr;
  };
  int64_t ans = sqr(n - 2);
  dfs(0, -1);
  for (int i = 0; i < n; i++) {
    for (int j = i + 1; j < n; j++) {
      int u = i;
      int v = j;
      if (tin[u] > tin[v]) {
        swap(u, v);
      }
      int64_t cur = 0;
      if (tin[u] <= tin[v] && tout[v] <= tout[u]) {
        for (auto to : ed[u]) {
          if (sz[to] > sz[u]) {
            cur += sqr(n - sz[u]);
          } else if (tin[to] <= tin[v] && tout[v] <= tout[to]) {
            cur += sqr(sz[to] - sz[v]);
          } else {
            cur += sqr(sz[to]);
          }
        }
        for (auto to : ed[v]) {
          if (sz[to] < sz[v]) {
            cur += sqr(sz[to]);
          }
        }
      } else {
        for (auto to : ed[u]) {
          if (sz[to] < sz[u]) {
            cur += sqr(sz[to]);
          }
        }
        for (auto to : ed[v]) {
          if (sz[to] < sz[v]) {
            cur += sqr(sz[to]);
          }
        }
        cur += sqr(n - sz[u] - sz[v]);
      }
      if (cur < ans) {
        ans = cur;
      }
    }
  }
  cout << ans << endl;
}
